"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = require("axios");
var uuid_1 = require("./uuid");
var PlaybackStateTracker = /** @class */ (function () {
    function PlaybackStateTracker(config, videoDurationSeconds) {
        var _this = this;
        this.config = config;
        this.videoDurationSeconds = videoDurationSeconds;
        this.onPlay = function (currentTime) {
            _this.segmentPlaybackStartTime = currentTime;
            if (_this.config.onPlay) {
                _this.config.onPlay();
            }
        };
        this.onPause = function (currentTime) {
            if (_this.segmentPlaybackStartTime === -1) {
                return;
            }
            var playbackEvent = __assign({}, _this.config.eventExtraData, { captureTime: new Date(), playerId: _this.playerId, segmentStartSeconds: _this.segmentPlaybackStartTime, segmentEndSeconds: currentTime, videoDurationSeconds: _this.videoDurationSeconds });
            if (_this.config.onSegmentWatched) {
                _this.config.onSegmentWatched(playbackEvent);
            }
            if (_this.config.trackingEndpoint) {
                axios_1.default.post(_this.config.trackingEndpoint, playbackEvent);
            }
            _this.segmentPlaybackStartTime = -1;
        };
        this.segmentPlaybackStartTime = -1;
        this.playerId = uuid_1.uuid();
    }
    return PlaybackStateTracker;
}());
exports.default = PlaybackStateTracker;
//# sourceMappingURL=PlaybackStateTracker.js.map