"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = require("classnames");
var Hls = require("hls.js");
var Plyr = require("plyr");
var React = require("react");
var StreamPlayback = /** @class */ (function (_super) {
    __extends(StreamPlayback, _super);
    function StreamPlayback() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.hls = null;
        _this.state = {
            fullscreen: false,
        };
        _this.onPlay = function (e) {
            // @ts-ignore
            if (e.target.plyr) {
                _this.props.tracker.onPlay(
                // @ts-ignore
                e.target.plyr.media.currentTime);
            }
            if (_this.props.onPlay) {
                _this.props.onPlay();
            }
        };
        _this.onPause = function (e) {
            // @ts-ignore
            if (e.target.plyr) {
                // @ts-ignore
                _this.props.tracker.onPause(e.target.plyr.media.currentTime);
            }
        };
        _this.onEnterFullscreen = function () {
            _this.setState({ fullscreen: true });
        };
        _this.onExitFullscreen = function () {
            _this.setState({ fullscreen: false });
        };
        return _this;
    }
    StreamPlayback.prototype.render = function () {
        return (React.createElement("div", { className: classnames_1.default('boclips-player-container', {
                'boclips-player-container--fullscreen': this.state.fullscreen,
            }) },
            React.createElement("video", { ref: this.props.videoRef, className: "boclips-player--playback", "data-qa": "video-playback", width: "500", controls: true, onPlay: this.onPlay, onPause: this.onPause, poster: this.props.thumbnailUrl, preload: "none", src: this.props.stream })));
    };
    StreamPlayback.prototype.componentDidMount = function () {
        var _this = this;
        var player = new Plyr(this.props.videoRef.current, {
            controls: this.props.controls,
            captions: { active: false, language: 'en', update: true },
            debug: false,
        });
        player.on('play', function (event) {
            if (_this.hls) {
                _this.hls.startLoad();
            }
            _this.onPlay(event);
        });
        player.on('pause', function (event) {
            _this.onPause(event);
        });
        player.on('enterfullscreen', function () {
            _this.onEnterFullscreen();
        });
        player.on('exitfullscreen', function () {
            _this.onExitFullscreen();
        });
        player.on('ready', function () {
            player.toggleControls(false);
        });
        if (Hls.isSupported()) {
            this.hls = new Hls({ autoStartLoad: false });
            this.hls.loadSource(this.props.stream);
            this.hls.attachMedia(this.props.videoRef.current);
        }
        else if (this.props.videoRef.current.canPlayType('application/vnd.apple.mpegurl')) {
            this.props.videoRef.current.addEventListener('loadedmetadata', function () {
                _this.props.videoRef.current.play();
            });
        }
    };
    StreamPlayback.prototype.componentWillUnmount = function () {
        this.props.tracker.onPause(this.props.videoRef.current.currentTime);
    };
    return StreamPlayback;
}(React.Component));
exports.StreamPlayback = StreamPlayback;
//# sourceMappingURL=StreamPlayback.js.map