"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = require("classnames");
var Plyr = require("plyr");
var React = require("react");
var YoutubePlayback = /** @class */ (function (_super) {
    __extends(YoutubePlayback, _super);
    function YoutubePlayback() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.player = null;
        _this.state = {
            fullscreen: false,
        };
        _this.onPlay = function (e) {
            _this.props.tracker.onPlay(
            // @ts-ignore
            e.detail.plyr.media.currentTime);
            if (_this.props.onPlay) {
                _this.props.onPlay();
            }
        };
        _this.onPause = function (e) {
            // @ts-ignore
            _this.props.tracker.onPause(e.detail.plyr.media.currentTime);
        };
        _this.onEnterFullscreen = function () {
            _this.setState({ fullscreen: true });
        };
        _this.onExitFullscreen = function () {
            _this.setState({ fullscreen: false });
        };
        return _this;
    }
    YoutubePlayback.prototype.render = function () {
        return (React.createElement(React.Fragment, null,
            React.createElement("div", { className: classnames_1.default('boclips-player-container', {
                    'boclips-player-container--fullscreen': this.state.fullscreen,
                }) },
                React.createElement("div", { ref: this.props.videoRef, id: "player", "data-plyr-provider": "youtube", "data-plyr-embed-id": this.props.youtubeId }))));
    };
    YoutubePlayback.prototype.componentDidMount = function () {
        var _this = this;
        this.player = new Plyr(this.props.videoRef.current, {
            controls: this.props.controls,
        });
        this.player.on('play', function (event) {
            _this.onPlay(event);
        });
        this.player.on('pause', function (event) {
            _this.onPause(event);
        });
        this.player.on('ready', function () {
            _this.player.toggleControls(false);
        });
        this.player.on('enterfullscreen', function () {
            _this.onEnterFullscreen();
        });
        this.player.on('exitfullscreen', function () {
            _this.onExitFullscreen();
        });
    };
    YoutubePlayback.prototype.componentWillUnmount = function () {
        this.props.tracker.onPause(this.player.currentTime);
    };
    return YoutubePlayback;
}(React.Component));
exports.YoutubePlayback = YoutubePlayback;
//# sourceMappingURL=YoutubePlayback.js.map